HIGH, MEDIUM, LOW, NOPRIORITY = list(range(4))
STRINGS = {
    HIGH: 'High',
    MEDIUM: 'Medium',
    LOW: 'Low',
    NOPRIORITY: '',
}
LOOKUP = {
    'High': HIGH,
    'Medium': MEDIUM,
    'Low': LOW,
    '': NOPRIORITY,
}

class Priority(object):
    pv = NOPRIORITY

    def __init__(self, pv = NOPRIORITY):
        self._parse_init_value(pv);

    def _parse_init_value(self, pv):
        if pv is None:
            _parse_init_value(self, NOPRIORITY)
        elif isinstance(pv, int):
            if pv in (HIGH, MEDIUM, LOW, NOPRIORITY):
                self.pv = pv
        else:
            raise ValueError("Unknown value for priority: '%s'" % pv)

    @classmethod
    def no_priority(cls):
        return Priority()

    def set_priority(self, pv):
        self._parse_init_value(pv)

    @staticmethod
    def get_priority_strings():
        return STRINGS.values()

    def to_readable_string(self):
        return STRINGS[self.pv]

    @staticmethod
    def compare(p1, p2):
        return (p1.pv > p2.pv) - (p1.pv < p2.pv)

